subroutine sub_myinterp3(x,f_x,length_index,xp,interp_value)

	use mod_types
	use mod_common_var

	implicit none

	integer, intent(in) :: length_index

	real (dp), dimension(length_index), intent(in) :: x
	real (dp), dimension(length_index, n_tauchen), intent(in) :: f_x
	real (dp), intent(in) :: xp
	real (dp), dimension(n_tauchen), intent(out) :: interp_value
	
	real (dp), dimension(n_tauchen) :: t
	
	if (xp>x(2) .and. length_index == 3) then
		t = (f_x(3,:)-f_x(2,:))/(x(3)-x(2))
		interp_value = t*(xp-x(2))+f_x(2,:)
	else
		t = (f_x(2,:)-f_x(1,:))/(x(2)-x(1))
		interp_value = t*(xp-x(1))+f_x(1,:)
	endif
  					 
end subroutine sub_myinterp3